Imports NationalInstruments.VisaNS

Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        REM  ##############################################
        REM  
        REM    M3500A configure VOLTage:AC ,sample count 5
        REM
        REM    Using NI-VISA Visual Studio 2005 dotnet NationalInstruments.VisaNS
        REM
        REM  ##############################################

        Dim resources() As String     ' The ResourceManager find resource array
        Dim workrs As String          ' The working device resource name 
        Dim s As String
        Dim sw As Boolean
        Dim i As Integer
        Dim j As Integer
        Dim tom As Integer            ' Timeout value

        '
        ' Clear the ListBox
        '
        Do While (ListBox1.Items.Count > 0)
            ListBox1.Items().RemoveAt(0)
        Loop

        Dim sm As NationalInstruments.VisaNS.MessageBasedSession
        Dim responseString As String

        '
        ' Check the Resource Manager all the resources
        ' find the M3500A device for "USB0::0x164E::0x0DAD"
        '
        resources = ResourceManager.GetLocalManager().FindResources("?*")
        sw = True
        For Each s In resources
            If s.Contains("0x164E::0x0DAD") Then
                sw = False
                workrs = s
                Exit For
            End If
        Next

        If sw Then
            MsgBox("M3500A USB device not found.")
            Exit Sub
        End If
        ' Set the working device -- open the session
        ' set the device to the initialize state -- *RST, *CLS
        '
        sm = ResourceManager.GetLocalManager().Open(workrs)
        sm.Write("*RST")
        sm.Write("*CLS")
        '
        ' Set the function CONF:VOLT:AC 1,0.001 and Math function DBM 50
        '
        sm.Write("CALC:DBM:REF 50")
        sm.Write("CONF:VOLT:AC 1,0.001")
        '
        ' Set the BandWidth 200 and the sample count 5
        '
        sm.Write("DET:BAND 200")
        sm.Write("SAMP:COUN 5")
        '
        ' Set the Trigger Source Immediate
        '
        sm.Write("TRIG:SOUR IMM")
        sm.Write("CALC:FUNC DBM")

        sm.Write("CALC:STAT ON")
        sm.Write("READ?")
        '
        ' Read the measures and show the readings on the ListBox
        '
        tom = sm.Timeout()
        sm.Timeout() = 60000
        responseString = sm.ReadString()
        j = 0
        For i = 0 To 4
            ListBox1.Items.Insert(i, responseString.Substring(j, 15))
            j = (i + 1) * 16
        Next
        '
        ' Set the M3500A to local mode
        '
        sm.Timeout() = tom
        sm.Write("system:local")
        sm.Dispose()
        MsgBox("End of Job.", MsgBoxStyle.Information, "M3500A Configure example")

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        End
    End Sub
End Class
